#include <stdlib.h>
#include <stdio.h>

typedef unsigned char uchar;

int getint(fd)
  FILE *fd;
{
  int c, i;
  char dummy[10000];

  c = getc(fd);
  while (1) 
  {
    if (c=='#')  
      fgets(dummy,9000,fd);
    if (c==EOF) {
      printf("Image %s not binary PGM.\n","is");
      exit(1);
    }

    if (c>='0' && c<='9')
      break;  
 
    c = getc(fd);
  }

  i = 0;
  while (1) {
    i = (i*10) + (c - '0');
    c = getc(fd);
    if (c==EOF) return (i);
    if (c<'0' || c>'9') break;
  }

  return (i);
}


void 
get_image(char *filename, unsigned char **in) {
FILE  *fd;
char header [100];
int  tmp;

  if((fd=fopen(filename,"r")) == NULL) {
    printf("Can't input image %s.\n",filename);
    exit(1);
  }

  header[0]=fgetc(fd);
  header[1]=fgetc(fd);
  if(!(header[0]=='P' && header[1]=='5')) {
    printf("Image %s does not have binary PGM header.\n",filename);
    exit(1);
   }

  x_size = getint(fd);
  y_size = getint(fd);
  tmp = getint(fd);

  *in = (uchar *) malloc(x_size * y_size);

   if (fread(*in,1,x_size * y_size,fd) == 0) {
     printf("Image %s is wrong size.\n",filename);
   }
 
  fclose(fd);
}

static int fcount = 0;
static char *files[2] = { "input_large.pgm", "li.pgm" };
static counter = 0;

void
compute() {
uchar *in;

     get_image(files[fcount], &in);
     fcount = (fcount + 1) % numberOfFiles;
     sendAll("image", in, x_size * y_size);

     counter++;
     if(counter == stopWhen) {
         free(in);
         stopExecution();
     }

     free(in);
}
